use std::str::Chars;
use std::iter::FromIterator;
use std::process::exit;

#[cfg(test)]
mod tests {
    use crate::*;

    #[test]
    fn test_00() {
        dbg!(parse_args("Hello world", 0x00));
    }
    #[test]
    fn test_01() {
        dbg!(parse_args("Hello world", 0x01));
    }
    #[test]
    fn test_02() {
        dbg!(parse_args("Hello worLd", 0x02));
    }
}

/// Parses the command line arguments into a list of parameters.
/// The following parsing modes can be utilized:
/// 00: Returns exactly what was inputted.
/// 01: Returns the contents, split by whitespace indiscriminately.
/// 02: Returns the contents, split by whitespace indiscriminately and made lowercase.
pub fn parse_args(input: &str, mode: u8) -> Vec<String> {
    let split_input: Vec<_> = input.chars().map(|arg| arg.clone()).collect(); // Converts from the input string to a vector of chars.
    dbg!(&split_input);
    match mode {
        0x00 => {vec![String::from_iter(split_input.iter())]}, // Simply converts the vector of chars into a string, and puts it as the first element.
        0x01 => {
            return input
                .to_string()
                .split_ascii_whitespace()
                .map(|x| x.to_string())
                .collect();
        }
        0x02 => {
            return input
                .to_string()
                .to_ascii_lowercase()
                .split_ascii_whitespace()
                .map(|x| x.to_string())
                .collect();
        }
        _ => panic!("Unexpected input")
    }
}